#include <stdio.h>
#include <ctype.h>
#include <string.h>


/*
 * An implementation of strstr() with case-insensitivity.
 */
char *strcasestr(const char *haystack, const char *needle)
{
    char *h, *n, *c;
    size_t hl, nl;

    c = (char *) haystack;
    n = (char *) needle;
    hl = strlen(haystack);
    nl = strlen(needle);

    while (hl >= nl) {
	while (tolower(*c) != tolower(*needle)) {
	    c++;
	    hl--;
	    if (hl < nl)
		return NULL;
	}

	h = c;
	n = (char *) needle;

	while (tolower(*h) == tolower(*n)) {
	    h++;
	    n++;

	    if (!*n)
		return c;
	}
	c++;
	hl--;
    }

    return NULL;
}


/*
 * Convert an unsigned long int to a string.
 */
char *ultostr(unsigned long int num, int base)
{
    unsigned int d;
    static char s[65];
    char *c;

    if (base < 2 || base > 36)
	return NULL;

    c = s + 64;
    *c = 0;

    do {
	d = num % base;
	num /= base;

	if (d <= 9)
	    *--c = '0' + d;
	else
	    *--c = 'a' + d - 10;
    } while (num);

    return c;
}
